From 3d589111903e823c9fab3a94e42a7339ad9edd89 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Mattias=20Engdeg=C3=A5rd?= <mattiase@acm.org>
Date: Fri, 14 Feb 2020 21:26:20 +0100
Subject: [PATCH 1/2] Speed up 'maven' compilation error message regexp

Anchor the regexp at line-start to prevent quadratic behaviour when
it doesn't match (bug#39595).

* lisp/progmodes/compile.el (compilation-error-regexp-alist-alist):
Rewrite 'maven' regexp, using rx for clarity.
---
 lisp/progmodes/compile.el | 18 +++++++++++++++++-
 1 file changed, 17 insertions(+), 1 deletion(-)

diff --git a/lisp/progmodes/compile.el b/lisp/progmodes/compile.el
index 48ac85a73b..65c2978c9e 100644
--- a/lisp/progmodes/compile.el
+++ b/lisp/progmodes/compile.el
@@ -273,7 +273,23 @@ compilation-error-regexp-alist-alist
     ;; due to matching filenames via \\(.*?\\).  This might be faster.
     (maven
      ;; Maven is a popular free software build tool for Java.
-     "\\(\\[WARNING\\] *\\)?\\([^ \n]\\(?:[^\n :]\\| [^-/\n]\\|:[^ \n]\\)*?\\):\\[\\([0-9]+\\),\\([0-9]+\\)\\] " 2 3 4 (1))
+     ,(rx bol
+          (? (* " ")
+             "["
+             (or "ERROR" (group-n 1 "WARNING") (group-n 2 "INFO"))
+             "]"
+             (+ " "))
+          (group-n 3
+                   (not (any "\n "))
+                   (* (| (not (any "\n :"))
+                         (: " " (not (any "\n/-")))
+                         (: ":" (not (any "\n ["))))))
+          ":["
+          (group-n 4 (+ digit))
+          ","
+          (group-n 5 (+ digit))
+          "] ")
+     3 4 5 (1 . 2))
 
     (jikes-line
      "^ *\\([0-9]+\\)\\.[ \t]+.*\n +\\(<-*>\n\\*\\*\\* \\(?:Error\\|Warnin\\(g\\)\\)\\)"
-- 
2.21.1 (Apple Git-122.3)

